<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>Z:/Project/development/PSCIP/driver/k_pscip.c File Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.7.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Z:/Project/development/PSCIP/driver/k_pscip.c File Reference</h1>Contains function directly interfacing hardware/kernel.  
<a href="#_details">More...</a>
<p>

<p>
<div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dynsection">
<p><center><img src="k__pscip_8c__dep__incl.gif" border="0" usemap="#Z:/Project/development/PSCIP/driver/k_pscip.cdep_map" alt=""></center>
</div>

<p>
<a href="k__pscip_8c-source.html">Go to the source code of this file.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#f3b7c646a7b12b9f333f71bb6ceb24af">MODULE_DEVICE_TABLE</a> (pci, <a class="el" href="k__pscip_8c.html#4a12a64d56df9af7c0af998356f07b01">ids</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Registering the table defining a list of the different types of CI devices that the driver supports.  <a href="#f3b7c646a7b12b9f333f71bb6ceb24af"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#2dab759a46d164a5ffb67021338afa8f">IP_read_byte</a> (void *address, uint8_t *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reads byte from the device.  <a href="#2dab759a46d164a5ffb67021338afa8f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#a45e2281c8ad6b553fae27e127629deb">IP_read_word</a> (void *address, uint16_t *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reads word from the device.  <a href="#a45e2281c8ad6b553fae27e127629deb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#fc42b873fc39adc8deeef3ad4264b880">IP_write_byte</a> (void *address, uint8_t <a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Writing byte to the device.  <a href="#fc42b873fc39adc8deeef3ad4264b880"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#bb54cb7c8617283657252ad4c51feb9a">IP_write_word</a> (void *address, uint16_t <a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Writing word to the device.  <a href="#bb54cb7c8617283657252ad4c51feb9a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#6784f6ad88e5d30a1844bf9f9fdba1d9">k_pscip_wait_linkdown</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Wait after linkdown.  <a href="#6784f6ad88e5d30a1844bf9f9fdba1d9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#6dc1abe4ae1b126bbefaca9925a8988e">k_pscip_wrhiprio</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Execute high priority PS-current setting.  <a href="#6dc1abe4ae1b126bbefaca9925a8988e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#3d09e7e118d65412fabd7a1a1b55cb8b">k_pscip_write</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Execute writing action.  <a href="#3d09e7e118d65412fabd7a1a1b55cb8b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#b0904bacdb30b392a67dd8f608e81506">k_pscip_read</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Execute reading action.  <a href="#b0904bacdb30b392a67dd8f608e81506"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#c6eb83f565e73ad37709b030d41fdade">k_pscip_wrwave</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Write wave value.  <a href="#c6eb83f565e73ad37709b030d41fdade"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#f10f5492ee6ba15616537fe09a8af161">k_pscip_rdwave</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Execute reading action Function reads data (2 words) of a waveform from given address in PS.  <a href="#f10f5492ee6ba15616537fe09a8af161"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#de6998fee8845158a60df6bcaacc9701">k_pscip_rdlinkstat</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Read link status.  <a href="#de6998fee8845158a60df6bcaacc9701"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#9236d56d760f8d28996dc67450fcaf4d">k_pscip_rdfpgastat</a> (<a class="el" href="structpscip__fpga__t.html">pscip_fpga_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Read FPGA status register FPGA status register is for debugging purposes and reflects the error status of the FPGA.  <a href="#9236d56d760f8d28996dc67450fcaf4d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#64870b39eafc9795c55e871b1f334c70">k_pscip_rdstatistics</a> (<a class="el" href="structpscip__stats__t.html">pscip_stats_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Read transmission statistics.  <a href="#64870b39eafc9795c55e871b1f334c70"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#4eb06abfb78b28f632aeb15a985a2abb">k_pscip_reset</a> (int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reset IP.  <a href="#4eb06abfb78b28f632aeb15a985a2abb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#af9fef4aaf709c65ab3b704e43fbfc5f">k_pscip_clear_err_counter</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clean error counter in FPGA status register.  <a href="#af9fef4aaf709c65ab3b704e43fbfc5f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#2e05daa62010e54bf8ee30a458db37d4">k_pscip_dump_all_registers</a> (<a class="el" href="structpscip__t.html">pscip_t</a> *<a class="el" href="test__prog_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>, int <a class="el" href="pscipacq_8c.html#c3b08da755e3580f678c98552d066a18">id_pscip</a>, <a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dumps content of all the registers of both IPs on the carrier and of Local Space O (BADR 2) on the Carrier.  <a href="#2e05daa62010e54bf8ee30a458db37d4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#4e412bef519930bb69a051c0b74d239f">k_irq_enable</a> (<a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Does hardware magic to enable interrupt on calling IP.  <a href="#4e412bef519930bb69a051c0b74d239f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#dfa986826cb900bf1bdc25e1c11c5722">k_irq_disable</a> (<a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Does hardware magic to disable interrupt on calling IP.  <a href="#dfa986826cb900bf1bdc25e1c11c5722"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#9a1d8049a6614cc5d9162f4dc0a78910">k_if_handle_irq</a> (<a class="el" href="structnpscip___dev.html">pscip_Dev</a> dev)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Veryfies the source of the interrupt.  <a href="#9a1d8049a6614cc5d9162f4dc0a78910"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#65191468c8f3208a293091c116479158">num_pscip</a> = 0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Number of registered devices.  <a href="#65191468c8f3208a293091c116479158"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="structnpscip___dev.html">npscip_Dev</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#d082de6fe736ef827509564e8980bc44">pscip_devices</a> [PSCIP_MAX_DEV]</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Static table of structures holding device datea.  <a href="#d082de6fe736ef827509564e8980bc44"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static struct pci_device_id&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="k__pscip_8c.html#4a12a64d56df9af7c0af998356f07b01">ids</a> []</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The structure is used to define a list of the different types of PCI devices that a driver supports.  <a href="#4a12a64d56df9af7c0af998356f07b01"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Contains function directly interfacing hardware/kernel. 
<p>
The file can be viewed like a lower layer of driver interface PSCIP Driver for Linux Kernel Functions to access hardware<p>
GG - 18.07.2005: First implementation GG - 08.02.2006: When setting status writew in the same stat and addr register<p>
22/10/2008 - Start of porting the driver :<ul>
<li>from 2.4.x to 2.6.x</li><li>from VME to PCIGG </li></ul>

<p>Definition in file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="2dab759a46d164a5ffb67021338afa8f"></a><!-- doxytag: member="k_pscip.c::IP_read_byte" ref="2dab759a46d164a5ffb67021338afa8f" args="(void *address, uint8_t *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IP_read_byte           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reads byte from the device. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*address</em>&nbsp;</td><td>- virtual address of the register to be read </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00035">35</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l01174">checkmem_device()</a>, <a class="el" href="k__pscip_8c-source.html#l00803">k_pscip_rdlinkstat()</a>, <a class="el" href="k__pscip_8c-source.html#l00693">k_pscip_rdwave()</a>, <a class="el" href="k__pscip_8c-source.html#l00431">k_pscip_read()</a>, <a class="el" href="k__pscip_8c-source.html#l00163">k_pscip_wrhiprio()</a>, <a class="el" href="k__pscip_8c-source.html#l00303">k_pscip_write()</a>, <a class="el" href="k__pscip_8c-source.html#l00561">k_pscip_wrwave()</a>, and <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="a45e2281c8ad6b553fae27e127629deb"></a><!-- doxytag: member="k_pscip.c::IP_read_word" ref="a45e2281c8ad6b553fae27e127629deb" args="(void *address, uint16_t *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IP_read_word           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reads word from the device. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*address</em>&nbsp;</td><td>- virtual address of the register to be read </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00047">47</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="k__pscip_8c-source.html#l01105">k_if_handle_irq()</a>, <a class="el" href="k__pscip_8c-source.html#l00974">k_pscip_dump_all_registers()</a>, <a class="el" href="k__pscip_8c-source.html#l00849">k_pscip_rdfpgastat()</a>, <a class="el" href="k__pscip_8c-source.html#l00693">k_pscip_rdwave()</a>, <a class="el" href="k__pscip_8c-source.html#l00431">k_pscip_read()</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8c-source.html#l00163">k_pscip_wrhiprio()</a>, <a class="el" href="k__pscip_8c-source.html#l00303">k_pscip_write()</a>, <a class="el" href="k__pscip_8c-source.html#l00561">k_pscip_wrwave()</a>, and <a class="el" href="pscip_8c-source.html#l00761">pscip_irq_handler()</a>.</p>

</div>
</div><p>
<a class="anchor" name="fc42b873fc39adc8deeef3ad4264b880"></a><!-- doxytag: member="k_pscip.c::IP_write_byte" ref="fc42b873fc39adc8deeef3ad4264b880" args="(void *address, uint8_t val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IP_write_byte           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Writing byte to the device. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*address</em>&nbsp;</td><td>- virtual address of the register to be writen to </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00060">60</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="k__pscip_8c-source.html#l00951">k_pscip_clear_err_counter()</a>, and <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="bb54cb7c8617283657252ad4c51feb9a"></a><!-- doxytag: member="k_pscip.c::IP_write_word" ref="bb54cb7c8617283657252ad4c51feb9a" args="(void *address, uint16_t val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IP_write_word           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Writing word to the device. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*address</em>&nbsp;</td><td>- virtual address of the register to be writen to </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00073">73</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="k__pscip_8c-source.html#l01079">k_irq_disable()</a>, <a class="el" href="k__pscip_8c-source.html#l01055">k_irq_enable()</a>, <a class="el" href="k__pscip_8c-source.html#l00951">k_pscip_clear_err_counter()</a>, <a class="el" href="k__pscip_8c-source.html#l00693">k_pscip_rdwave()</a>, <a class="el" href="k__pscip_8c-source.html#l00431">k_pscip_read()</a>, <a class="el" href="k__pscip_8c-source.html#l00919">k_pscip_reset()</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8c-source.html#l00163">k_pscip_wrhiprio()</a>, <a class="el" href="k__pscip_8c-source.html#l00303">k_pscip_write()</a>, <a class="el" href="k__pscip_8c-source.html#l00561">k_pscip_wrwave()</a>, and <a class="el" href="pscip_8c-source.html#l00761">pscip_irq_handler()</a>.</p>

</div>
</div><p>
<a class="anchor" name="9a1d8049a6614cc5d9162f4dc0a78910"></a><!-- doxytag: member="k_pscip.c::k_if_handle_irq" ref="9a1d8049a6614cc5d9162f4dc0a78910" args="(pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_if_handle_irq           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Veryfies the source of the interrupt. 
<p>
It checks whether the interupt was triggered by an IP represented by dev device structure registerred with given interrupt handler<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>- returns number of channel which triggered the interrupt or error </dd></dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l01105">1105</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="k__pscip_8h-source.html#l00147">IP_INT0_A</a>, <a class="el" href="k__pscip_8h-source.html#l00145">IP_INT0_B</a>, <a class="el" href="k__pscip_8h-source.html#l00146">IP_INT1_A</a>, <a class="el" href="k__pscip_8h-source.html#l00144">IP_INT1_B</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00122">IP_STATUS</a>, <a class="el" href="k__pscip_8h-source.html#l00210">npscip_Dev::IPnumber</a>, and <a class="el" href="k__pscip_8h-source.html#l00207">npscip_Dev::pIPinterfaceReg</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00761">pscip_irq_handler()</a>.</p>

</div>
</div><p>
<a class="anchor" name="dfa986826cb900bf1bdc25e1c11c5722"></a><!-- doxytag: member="k_pscip.c::k_irq_disable" ref="dfa986826cb900bf1bdc25e1c11c5722" args="(pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_irq_disable           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Does hardware magic to disable interrupt on calling IP. 
<p>
Called when last reference to give IP (/dev/pscipX) is closed<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l01079">1079</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="k__pscip_8h-source.html#l00119">IP_A_CONTROL</a>, <a class="el" href="k__pscip_8h-source.html#l00120">IP_B_CONTROL</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00210">npscip_Dev::IPnumber</a>, and <a class="el" href="k__pscip_8h-source.html#l00207">npscip_Dev::pIPinterfaceReg</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00250">pscip_release()</a>.</p>

</div>
</div><p>
<a class="anchor" name="4e412bef519930bb69a051c0b74d239f"></a><!-- doxytag: member="k_pscip.c::k_irq_enable" ref="4e412bef519930bb69a051c0b74d239f" args="(pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_irq_enable           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Does hardware magic to enable interrupt on calling IP. 
<p>
Called when first reference to give IP (/dev/pscipX) is openned Interrupt 0 is triggered by channel/link 0 Interrupt 1 is triggered by channel/link 1<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l01055">1055</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="k__pscip_8h-source.html#l00119">IP_A_CONTROL</a>, <a class="el" href="k__pscip_8h-source.html#l00120">IP_B_CONTROL</a>, <a class="el" href="k__pscip_8h-source.html#l00127">IP_INT0_EN</a>, <a class="el" href="k__pscip_8h-source.html#l00126">IP_INT1_EN</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00210">npscip_Dev::IPnumber</a>, and <a class="el" href="k__pscip_8h-source.html#l00207">npscip_Dev::pIPinterfaceReg</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00200">pscip_open()</a>.</p>

</div>
</div><p>
<a class="anchor" name="af9fef4aaf709c65ab3b704e43fbfc5f"></a><!-- doxytag: member="k_pscip.c::k_pscip_clear_err_counter" ref="af9fef4aaf709c65ab3b704e43fbfc5f" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_clear_err_counter           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clean error counter in FPGA status register. 
<p>
Error coutner indicates the number of errors which occured (ex. due to transmition error). The couter is clean before every read/write function from/to PS<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00951">951</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="k__pscip_8c-source.html#l00060">IP_write_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="pscip_8h-source.html#l00076">PSCIP_ERRCLEAR_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00053">PSCIP_FPGA_HIGH</a>, and <a class="el" href="k__pscip_8h-source.html#l00055">PSCIP_FPGA_LOW</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="2e05daa62010e54bf8ee30a458db37d4"></a><!-- doxytag: member="k_pscip.c::k_pscip_dump_all_registers" ref="2e05daa62010e54bf8ee30a458db37d4" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_dump_all_registers           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dumps content of all the registers of both IPs on the carrier and of Local Space O (BADR 2) on the Carrier. 
<p>
Local Space 0 contains IP A/B control registers, revision ID and status register. It does not metter which IP calles the function, it always dumps information for entire carrier address I/O space used for interfacing IPs IF __DEBUG__ defined, it also interprets content of registers in FPGA status register of calling IP and content of PCI Carrier Status register<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00974">974</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00210">npscip_Dev::IPnumber</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00207">npscip_Dev::pIPinterfaceReg</a>, <a class="el" href="k__pscip_8h-source.html#l00206">npscip_Dev::pPCIinterfaceReg</a>, <a class="el" href="k__pscip_8h-source.html#l00099">PSCIP_CHAN_OFFSET</a>, and <a class="el" href="k__pscip_8h-source.html#l00100">PSCIP_IP_OFFSET</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="9236d56d760f8d28996dc67450fcaf4d"></a><!-- doxytag: member="k_pscip.c::k_pscip_rdfpgastat" ref="9236d56d760f8d28996dc67450fcaf4d" args="(pscip_fpga_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_rdfpgastat           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__fpga__t.html">pscip_fpga_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Read FPGA status register FPGA status register is for debugging purposes and reflects the error status of the FPGA. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure reflecting status registers in FPGA - is filled with IP debug information </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00849">849</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00033">pscip_fpga_t::channel</a>, <a class="el" href="pscip_8h-source.html#l00034">pscip_fpga_t::high_data</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="pscip_8h-source.html#l00034">pscip_fpga_t::low_data</a>, <a class="el" href="pscip_8h-source.html#l00034">pscip_fpga_t::mid_data</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00053">PSCIP_FPGA_HIGH</a>, <a class="el" href="k__pscip_8h-source.html#l00055">PSCIP_FPGA_LOW</a>, and <a class="el" href="k__pscip_8h-source.html#l00054">PSCIP_FPGA_MID</a>.</p>

<p>Referenced by <a class="el" href="debug__pscip_8c-source.html#l00280">IP_DEBUG_read_errors()</a>, <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscip_8c-source.html#l00879">pscip_read_proc()</a>.</p>

</div>
</div><p>
<a class="anchor" name="de6998fee8845158a60df6bcaacc9701"></a><!-- doxytag: member="k_pscip.c::k_pscip_rdlinkstat" ref="de6998fee8845158a60df6bcaacc9701" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_rdlinkstat           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Read link status. 
<p>
Reads FPGA status register <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure reflecting status registers in FPGA - is filled with IP debug information </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00803">803</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00023">PSCIP_HPRIOWRITE_STAT</a>, <a class="el" href="pscip_8h-source.html#l00177">PSCIP_PARAM_ERR</a>, <a class="el" href="pscip_8h-source.html#l00136">PSCIP_RDWAVE_IDX</a>, <a class="el" href="k__pscip_8h-source.html#l00043">PSCIP_RDWAVE_STAT</a>, <a class="el" href="pscip_8h-source.html#l00134">PSCIP_READ_IDX</a>, <a class="el" href="k__pscip_8h-source.html#l00033">PSCIP_READ_STAT</a>, <a class="el" href="pscip_8h-source.html#l00132">PSCIP_WRHPRIO_IDX</a>, <a class="el" href="pscip_8h-source.html#l00133">PSCIP_WRITE_IDX</a>, <a class="el" href="k__pscip_8h-source.html#l00028">PSCIP_WRITE_STAT</a>, <a class="el" href="pscip_8h-source.html#l00135">PSCIP_WRWAVE_IDX</a>, and <a class="el" href="k__pscip_8h-source.html#l00038">PSCIP_WRWAVE_STAT</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="64870b39eafc9795c55e871b1f334c70"></a><!-- doxytag: member="k_pscip.c::k_pscip_rdstatistics" ref="64870b39eafc9795c55e871b1f334c70" args="(pscip_stats_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_rdstatistics           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__stats__t.html">pscip_stats_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Read transmission statistics. 
<p>
Retursn to the user all the information about errors stored in device structure during operation of the driver. It does not read informatin from IP but rather from device structure flags.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure filled with the information about errors </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00884">884</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8c-source.html#l00069">__DEBUG__</a>, <a class="el" href="pscip_8h-source.html#l00041">pscip_stats_t::channel</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::link_err_flag</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::linkdown_cnt</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::rx</a>, <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::tx</a>, and <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::txerr_cnt</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="f10f5492ee6ba15616537fe09a8af161"></a><!-- doxytag: member="k_pscip.c::k_pscip_rdwave" ref="f10f5492ee6ba15616537fe09a8af161" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_rdwave           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Execute reading action Function reads data (2 words) of a waveform from given address in PS. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00693">693</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::cntrl_stat</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00191">npscip_Dev::irqflag</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8h-source.html#l00189">npscip_Dev::lock</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00102">PSCIP_BUSY_TOUT</a>, <a class="el" href="pscip_8h-source.html#l00059">PSCIP_DSP_MSK</a>, <a class="el" href="pscip_8h-source.html#l00066">PSCIP_ERROR_MSK</a>, <a class="el" href="pscip_8h-source.html#l00058">PSCIP_INPUTBUF_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00088">PSCIP_IRQ_DONE</a>, <a class="el" href="k__pscip_8h-source.html#l00086">PSCIP_IRQ_REQUEST</a>, <a class="el" href="k__pscip_8h-source.html#l00087">PSCIP_IRQ_SERVED</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00061">PSCIP_LINK_MSK</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00045">PSCIP_RDWAVE_DATA</a>, <a class="el" href="k__pscip_8h-source.html#l00042">PSCIP_RDWAVE_REG</a>, <a class="el" href="k__pscip_8h-source.html#l00043">PSCIP_RDWAVE_STAT</a>, <a class="el" href="pscip_8h-source.html#l00060">PSCIP_REMLOC_MSK</a>, <a class="el" href="pscip_8h-source.html#l00172">PSCIP_TOUT_ERR</a>, <a class="el" href="pscip_8h-source.html#l00176">PSCIP_TX_ERR</a>, <a class="el" href="k__pscip_8h-source.html#l00188">npscip_Dev::queue</a>, <a class="el" href="pscip_8c-source.html#l00091">queue_flag</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::rx</a>, <a class="el" href="pscip_8h-source.html#l00024">pscip_t::stat</a>, and <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>.</p>

</div>
</div><p>
<a class="anchor" name="b0904bacdb30b392a67dd8f608e81506"></a><!-- doxytag: member="k_pscip.c::k_pscip_read" ref="b0904bacdb30b392a67dd8f608e81506" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_read           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Execute reading action. 
<p>
Function reads data (2 words) from a given address in PS<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00431">431</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::cntrl_stat</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00191">npscip_Dev::irqflag</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8h-source.html#l00189">npscip_Dev::lock</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00102">PSCIP_BUSY_TOUT</a>, <a class="el" href="pscip_8h-source.html#l00059">PSCIP_DSP_MSK</a>, <a class="el" href="pscip_8h-source.html#l00066">PSCIP_ERROR_MSK</a>, <a class="el" href="pscip_8h-source.html#l00058">PSCIP_INPUTBUF_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00088">PSCIP_IRQ_DONE</a>, <a class="el" href="k__pscip_8h-source.html#l00086">PSCIP_IRQ_REQUEST</a>, <a class="el" href="k__pscip_8h-source.html#l00087">PSCIP_IRQ_SERVED</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00061">PSCIP_LINK_MSK</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00034">PSCIP_READ_ADDR</a>, <a class="el" href="k__pscip_8h-source.html#l00035">PSCIP_READ_DATA</a>, <a class="el" href="k__pscip_8h-source.html#l00032">PSCIP_READ_REG</a>, <a class="el" href="k__pscip_8h-source.html#l00033">PSCIP_READ_STAT</a>, <a class="el" href="pscip_8h-source.html#l00060">PSCIP_REMLOC_MSK</a>, <a class="el" href="pscip_8h-source.html#l00172">PSCIP_TOUT_ERR</a>, <a class="el" href="pscip_8h-source.html#l00176">PSCIP_TX_ERR</a>, <a class="el" href="k__pscip_8h-source.html#l00188">npscip_Dev::queue</a>, <a class="el" href="pscip_8c-source.html#l00091">queue_flag</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::rx</a>, <a class="el" href="pscip_8h-source.html#l00024">pscip_t::stat</a>, and <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscipacq_8c-source.html#l00052">pscip_thread()</a>.</p>

</div>
</div><p>
<a class="anchor" name="4eb06abfb78b28f632aeb15a985a2abb"></a><!-- doxytag: member="k_pscip.c::k_pscip_reset" ref="4eb06abfb78b28f632aeb15a985a2abb" args="(int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_reset           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reset IP. 
<p>
This is a hardware reset which is triggered from the Carrier.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00919">919</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="k__pscip_8h-source.html#l00121">IP_RESET</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00210">npscip_Dev::IPnumber</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, and <a class="el" href="k__pscip_8h-source.html#l00207">npscip_Dev::pIPinterfaceReg</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscip_8c-source.html#l00964">pscip_write_proc()</a>.</p>

</div>
</div><p>
<a class="anchor" name="6784f6ad88e5d30a1844bf9f9fdba1d9"></a><!-- doxytag: member="k_pscip.c::k_pscip_wait_linkdown" ref="6784f6ad88e5d30a1844bf9f9fdba1d9" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_wait_linkdown           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Wait after linkdown. 
<p>
Wait some seconds after a linkdown event, maybe to avoid requesting data after a local control unit reboot<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00092">92</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::linkdown_cnt</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="pscip_8h-source.html#l00076">PSCIP_ERRCLEAR_MSK</a>, <a class="el" href="pscip_8h-source.html#l00083">PSCIP_ERRCNT_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00053">PSCIP_FPGA_HIGH</a>, <a class="el" href="k__pscip_8h-source.html#l00055">PSCIP_FPGA_LOW</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="pscip_8h-source.html#l00138">PSCIP_LINKDOWN_TOUT</a>, <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>, and <a class="el" href="k__pscip_8h-source.html#l00195">npscip_Dev::tv</a>.</p>

<p>Referenced by <a class="el" href="k__pscip_8c-source.html#l00693">k_pscip_rdwave()</a>, <a class="el" href="k__pscip_8c-source.html#l00431">k_pscip_read()</a>, <a class="el" href="k__pscip_8c-source.html#l00163">k_pscip_wrhiprio()</a>, <a class="el" href="k__pscip_8c-source.html#l00303">k_pscip_write()</a>, and <a class="el" href="k__pscip_8c-source.html#l00561">k_pscip_wrwave()</a>.</p>

</div>
</div><p>
<a class="anchor" name="6dc1abe4ae1b126bbefaca9925a8988e"></a><!-- doxytag: member="k_pscip.c::k_pscip_wrhiprio" ref="6dc1abe4ae1b126bbefaca9925a8988e" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_wrhiprio           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Execute high priority PS-current setting. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00163">163</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::cntrl_stat</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00191">npscip_Dev::irqflag</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8h-source.html#l00189">npscip_Dev::lock</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00102">PSCIP_BUSY_TOUT</a>, <a class="el" href="pscip_8h-source.html#l00059">PSCIP_DSP_MSK</a>, <a class="el" href="pscip_8h-source.html#l00057">PSCIP_ECHO_MSK</a>, <a class="el" href="pscip_8h-source.html#l00066">PSCIP_ERROR_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00025">PSCIP_HPRIOWRITE_DATA</a>, <a class="el" href="k__pscip_8h-source.html#l00022">PSCIP_HPRIOWRITE_REG</a>, <a class="el" href="k__pscip_8h-source.html#l00023">PSCIP_HPRIOWRITE_STAT</a>, <a class="el" href="pscip_8h-source.html#l00058">PSCIP_INPUTBUF_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00088">PSCIP_IRQ_DONE</a>, <a class="el" href="k__pscip_8h-source.html#l00086">PSCIP_IRQ_REQUEST</a>, <a class="el" href="k__pscip_8h-source.html#l00087">PSCIP_IRQ_SERVED</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00061">PSCIP_LINK_MSK</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="pscip_8h-source.html#l00169">PSCIP_MISMATCH_ERR</a>, <a class="el" href="pscip_8h-source.html#l00060">PSCIP_REMLOC_MSK</a>, <a class="el" href="pscip_8h-source.html#l00172">PSCIP_TOUT_ERR</a>, <a class="el" href="pscip_8h-source.html#l00176">PSCIP_TX_ERR</a>, <a class="el" href="k__pscip_8h-source.html#l00188">npscip_Dev::queue</a>, <a class="el" href="pscip_8c-source.html#l00091">queue_flag</a>, <a class="el" href="pscip_8h-source.html#l00024">pscip_t::stat</a>, <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>, and <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::tx</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscip_8c-source.html#l00964">pscip_write_proc()</a>.</p>

</div>
</div><p>
<a class="anchor" name="3d09e7e118d65412fabd7a1a1b55cb8b"></a><!-- doxytag: member="k_pscip.c::k_pscip_write" ref="3d09e7e118d65412fabd7a1a1b55cb8b" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_write           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Execute writing action. 
<p>
The function writes given data (2 words) to given address in the PS, the information is passed with a given status.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00303">303</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::cntrl_stat</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00191">npscip_Dev::irqflag</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8h-source.html#l00189">npscip_Dev::lock</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00102">PSCIP_BUSY_TOUT</a>, <a class="el" href="pscip_8h-source.html#l00059">PSCIP_DSP_MSK</a>, <a class="el" href="pscip_8h-source.html#l00057">PSCIP_ECHO_MSK</a>, <a class="el" href="pscip_8h-source.html#l00066">PSCIP_ERROR_MSK</a>, <a class="el" href="pscip_8h-source.html#l00058">PSCIP_INPUTBUF_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00088">PSCIP_IRQ_DONE</a>, <a class="el" href="k__pscip_8h-source.html#l00086">PSCIP_IRQ_REQUEST</a>, <a class="el" href="k__pscip_8h-source.html#l00087">PSCIP_IRQ_SERVED</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00061">PSCIP_LINK_MSK</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="pscip_8h-source.html#l00169">PSCIP_MISMATCH_ERR</a>, <a class="el" href="pscip_8h-source.html#l00060">PSCIP_REMLOC_MSK</a>, <a class="el" href="pscip_8h-source.html#l00172">PSCIP_TOUT_ERR</a>, <a class="el" href="pscip_8h-source.html#l00176">PSCIP_TX_ERR</a>, <a class="el" href="k__pscip_8h-source.html#l00030">PSCIP_WRITE_DATA</a>, <a class="el" href="k__pscip_8h-source.html#l00027">PSCIP_WRITE_REG</a>, <a class="el" href="k__pscip_8h-source.html#l00028">PSCIP_WRITE_STAT</a>, <a class="el" href="k__pscip_8h-source.html#l00188">npscip_Dev::queue</a>, <a class="el" href="pscip_8c-source.html#l00091">queue_flag</a>, <a class="el" href="pscip_8h-source.html#l00024">pscip_t::stat</a>, <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>, and <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::tx</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscip_8c-source.html#l00964">pscip_write_proc()</a>.</p>

</div>
</div><p>
<a class="anchor" name="c6eb83f565e73ad37709b030d41fdade"></a><!-- doxytag: member="k_pscip.c::k_pscip_wrwave" ref="c6eb83f565e73ad37709b030d41fdade" args="(pscip_t *val, int id_pscip, pscip_Dev dev)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int k_pscip_wrwave           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpscip__t.html">pscip_t</a> *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>id_pscip</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structnpscip___dev.html">pscip_Dev</a>&nbsp;</td>
          <td class="paramname"> <em>dev</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Write wave value. 
<p>
Function writes datat (2 words) of waveform to given address in PS<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>*val</em>&nbsp;</td><td>- structure containing information about the channel/link we are using </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>id_pscip</em>&nbsp;</td><td>- number of the device ( IP ) we are using, if negative value, the device passed by third argument is used </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dev</em>&nbsp;</td><td>- device structure contaning informatin about the device (IP) </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00561">561</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>References <a class="el" href="pscip_8h-source.html#l00024">pscip_t::address</a>, <a class="el" href="pscip_8h-source.html#l00023">pscip_t::chan</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::cntrl_stat</a>, <a class="el" href="pscip_8h-source.html#l00026">pscip_t::data</a>, <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::err_flag</a>, <a class="el" href="k__pscip_8c-source.html#l00035">IP_read_byte()</a>, <a class="el" href="k__pscip_8c-source.html#l00047">IP_read_word()</a>, <a class="el" href="k__pscip_8c-source.html#l00073">IP_write_word()</a>, <a class="el" href="k__pscip_8h-source.html#l00191">npscip_Dev::irqflag</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8h-source.html#l00189">npscip_Dev::lock</a>, <a class="el" href="k__pscip_8c-source.html#l00016">num_pscip</a>, <a class="el" href="k__pscip_8h-source.html#l00208">npscip_Dev::pIP_IOspace</a>, <a class="el" href="k__pscip_8h-source.html#l00102">PSCIP_BUSY_TOUT</a>, <a class="el" href="pscip_8h-source.html#l00059">PSCIP_DSP_MSK</a>, <a class="el" href="pscip_8h-source.html#l00057">PSCIP_ECHO_MSK</a>, <a class="el" href="pscip_8h-source.html#l00066">PSCIP_ERROR_MSK</a>, <a class="el" href="pscip_8h-source.html#l00058">PSCIP_INPUTBUF_MSK</a>, <a class="el" href="k__pscip_8h-source.html#l00088">PSCIP_IRQ_DONE</a>, <a class="el" href="k__pscip_8h-source.html#l00086">PSCIP_IRQ_REQUEST</a>, <a class="el" href="k__pscip_8h-source.html#l00087">PSCIP_IRQ_SERVED</a>, <a class="el" href="pscip_8h-source.html#l00175">PSCIP_LINK_ERR</a>, <a class="el" href="pscip_8h-source.html#l00061">PSCIP_LINK_MSK</a>, <a class="el" href="pscip_8h-source.html#l00084">PSCIP_LINKDOWN_MSK</a>, <a class="el" href="pscip_8h-source.html#l00169">PSCIP_MISMATCH_ERR</a>, <a class="el" href="pscip_8h-source.html#l00060">PSCIP_REMLOC_MSK</a>, <a class="el" href="pscip_8h-source.html#l00172">PSCIP_TOUT_ERR</a>, <a class="el" href="pscip_8h-source.html#l00176">PSCIP_TX_ERR</a>, <a class="el" href="k__pscip_8h-source.html#l00040">PSCIP_WRWAVE_DATA</a>, <a class="el" href="k__pscip_8h-source.html#l00037">PSCIP_WRWAVE_REG</a>, <a class="el" href="k__pscip_8h-source.html#l00038">PSCIP_WRWAVE_STAT</a>, <a class="el" href="k__pscip_8h-source.html#l00188">npscip_Dev::queue</a>, <a class="el" href="pscip_8c-source.html#l00091">queue_flag</a>, <a class="el" href="pscip_8h-source.html#l00024">pscip_t::stat</a>, <a class="el" href="k__pscip_8h-source.html#l00187">npscip_Dev::stats</a>, and <a class="el" href="pscip_8h-source.html#l00042">pscip_stats_t::tx</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l00302">pscip_ioctl()</a>, and <a class="el" href="pscip_8c-source.html#l00964">pscip_write_proc()</a>.</p>

</div>
</div><p>
<a class="anchor" name="f3b7c646a7b12b9f333f71bb6ceb24af"></a><!-- doxytag: member="k_pscip.c::MODULE_DEVICE_TABLE" ref="f3b7c646a7b12b9f333f71bb6ceb24af" args="(pci, ids)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">MODULE_DEVICE_TABLE           </td>
          <td>(</td>
          <td class="paramtype">pci&nbsp;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="k__pscip_8c.html#4a12a64d56df9af7c0af998356f07b01">ids</a>&nbsp;</td>
          <td class="paramname"></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Registering the table defining a list of the different types of CI devices that the driver supports. 
<p>

</div>
</div><p>
<hr><h2>Variable Documentation</h2>
<a class="anchor" name="4a12a64d56df9af7c0af998356f07b01"></a><!-- doxytag: member="k_pscip.c::ids" ref="4a12a64d56df9af7c0af998356f07b01" args="[]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct pci_device_id <a class="el" href="k__pscip_8c.html#4a12a64d56df9af7c0af998356f07b01">ids</a>[]<code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>Initial value:</b><div class="fragment"><pre class="fragment"> {
 { PCI_DEVICE(<a class="code" href="k__pscip_8h.html#94c17ab355d288c787d55ed450a2ebf7">PCI_VENDOR_ID_TEWS</a>, <a class="code" href="k__pscip_8h.html#30826571b2cb0d72623b0391a0b696d9">PCI_DEVICE_ID_TCPI100_PCI</a>), },
 { PCI_DEVICE(<a class="code" href="k__pscip_8h.html#94c17ab355d288c787d55ed450a2ebf7">PCI_VENDOR_ID_TEWS</a>, <a class="code" href="k__pscip_8h.html#a783eb0e561b015162aaa99b190f0ef3">PCI_DEVICE_ID_TCP221_cPCI</a>), },
 { 0, }
}
</pre></div>The structure is used to define a list of the different types of PCI devices that a driver supports. 
<p>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00021">21</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

</div>
</div><p>
<a class="anchor" name="65191468c8f3208a293091c116479158"></a><!-- doxytag: member="k_pscip.c::num_pscip" ref="65191468c8f3208a293091c116479158" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="k__pscip_8c.html#65191468c8f3208a293091c116479158">num_pscip</a> = 0<code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Number of registered devices. 
<p>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00016">16</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="k__pscip_8c-source.html#l00951">k_pscip_clear_err_counter()</a>, <a class="el" href="k__pscip_8c-source.html#l00849">k_pscip_rdfpgastat()</a>, <a class="el" href="k__pscip_8c-source.html#l00803">k_pscip_rdlinkstat()</a>, <a class="el" href="k__pscip_8c-source.html#l00884">k_pscip_rdstatistics()</a>, <a class="el" href="k__pscip_8c-source.html#l00693">k_pscip_rdwave()</a>, <a class="el" href="k__pscip_8c-source.html#l00431">k_pscip_read()</a>, <a class="el" href="k__pscip_8c-source.html#l00919">k_pscip_reset()</a>, <a class="el" href="k__pscip_8c-source.html#l00092">k_pscip_wait_linkdown()</a>, <a class="el" href="k__pscip_8c-source.html#l00163">k_pscip_wrhiprio()</a>, <a class="el" href="k__pscip_8c-source.html#l00303">k_pscip_write()</a>, <a class="el" href="k__pscip_8c-source.html#l00561">k_pscip_wrwave()</a>, and <a class="el" href="pscip_8c-source.html#l01202">probe()</a>.</p>

</div>
</div><p>
<a class="anchor" name="d082de6fe736ef827509564e8980bc44"></a><!-- doxytag: member="k_pscip.c::pscip_devices" ref="d082de6fe736ef827509564e8980bc44" args="[PSCIP_MAX_DEV]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structnpscip___dev.html">npscip_Dev</a> <a class="el" href="k__pscip_8c.html#d082de6fe736ef827509564e8980bc44">pscip_devices</a>[PSCIP_MAX_DEV]<code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Static table of structures holding device datea. 
<p>

<p>Definition at line <a class="el" href="k__pscip_8c-source.html#l00018">18</a> of file <a class="el" href="k__pscip_8c-source.html">k_pscip.c</a>.</p>

<p>Referenced by <a class="el" href="pscip_8c-source.html#l01174">checkmem_device()</a>, <a class="el" href="pscip_8c-source.html#l01135">init_pscip()</a>, <a class="el" href="pscip_8c-source.html#l01455">init_pscip_module()</a>, <a class="el" href="pscip_8c-source.html#l01202">probe()</a>, <a class="el" href="pscip_8c-source.html#l00879">pscip_read_proc()</a>, <a class="el" href="pscip_8c-source.html#l00964">pscip_write_proc()</a>, and <a class="el" href="pscip_8c-source.html#l01393">remove()</a>.</p>

</div>
</div><p>
</div>
<hr size="1"><address style="text-align: right;"><small>Generated on Fri Dec 5 17:49:44 2008 by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.7.1 </small></address>
</body>
</html>
